##// END OF EJS Templates
USBBOOT is Back...
Unknown -
r568:8bda66042adb
parent child
Show More
@@ -1,99 +1,102
1 1 #
2 2 # Setup fstab and initramfs
3 3 #
4 4
5 5 # Load utility functions
6 6 . ./functions.sh
7 7
8 8 # Install and setup fstab
9 9 install_readonly files/mount/fstab "${ETC_DIR}/fstab"
10 10
11 if [ "$ENABLE_UBOOTUSB" = true ] ; then
12 sed -i "s/mmcblk0p1/sda1/" "${ETC_DIR}/fstab"
13 sed -i "s/mmcblk0p2/sda2/" "${ETC_DIR}/fstab"
14 fi
15
16 11 # Add usb/sda disk root partition to fstab
17 12 if [ "$ENABLE_SPLITFS" = true ] && [ "$ENABLE_CRYPTFS" = false ] ; then
18 13 sed -i "s/mmcblk0p2/sda1/" "${ETC_DIR}/fstab"
19 14 fi
20 15
21 16 # Add encrypted root partition to fstab and crypttab
22 17 if [ "$ENABLE_CRYPTFS" = true ] ; then
23 18 # Replace fstab root partition with encrypted partition mapping
24 19 sed -i "s/mmcblk0p2/mapper\/${CRYPTFS_MAPPING}/" "${ETC_DIR}/fstab"
25 20
26 21 # Add encrypted partition to crypttab and fstab
27 22 install_readonly files/mount/crypttab "${ETC_DIR}/crypttab"
28 23 echo "${CRYPTFS_MAPPING} /dev/mmcblk0p2 none luks,initramfs" >> "${ETC_DIR}/crypttab"
29 24
30 25 if [ "$ENABLE_SPLITFS" = true ] ; then
31 # Add usb/sda disk to crypttab
26 # Add usb/sda1 disk to crypttab
32 27 sed -i "s/mmcblk0p2/sda1/" "${ETC_DIR}/crypttab"
33 28 fi
34 29 fi
35 30
31 if [ "$ENABLE_USBBOOT" = true ] ; then
32 sed -i "s/mmcblk0p1/sda1/" "${ETC_DIR}/fstab"
33 sed -i "s/mmcblk0p2/sda2/" "${ETC_DIR}/fstab"
34
35 # Add usb/sda2 disk to crypttab
36 sed -i "s/mmcblk0p2/sda2/" "${ETC_DIR}/crypttab"
37 fi
38
36 39 # Generate initramfs file
37 40 if [ "$ENABLE_INITRAMFS" = true ] ; then
38 41 if [ "$ENABLE_CRYPTFS" = true ] ; then
39 42 # Include initramfs scripts to auto expand encrypted root partition
40 43 if [ "$EXPANDROOT" = true ] ; then
41 44 install_exec files/initramfs/expand_encrypted_rootfs "${ETC_DIR}/initramfs-tools/scripts/init-premount/expand_encrypted_rootfs"
42 45 install_exec files/initramfs/expand-premount "${ETC_DIR}/initramfs-tools/scripts/local-premount/expand-premount"
43 46 install_exec files/initramfs/expand-tools "${ETC_DIR}/initramfs-tools/hooks/expand-tools"
44 47 fi
45 48
46 49 if [ "$CRYPTFS_DROPBEAR" = true ]; then
47 50 if [ -n "$CRYPTFS_DROPBEAR_PUBKEY" ] && [ -f "$CRYPTFS_DROPBEAR_PUBKEY" ] ; then
48 51 install_readonly "${CRYPTFS_DROPBEAR_PUBKEY}" "${ETC_DIR}"/dropbear-initramfs/id_rsa.pub
49 52 cat "${ETC_DIR}"/dropbear-initramfs/id_rsa.pub >> "${ETC_DIR}"/dropbear-initramfs/authorized_keys
50 53 else
51 54 # Create key
52 55 chroot_exec /usr/bin/dropbearkey -t rsa -f /etc/dropbear-initramfs/id_rsa.dropbear
53 56
54 57 # Convert dropbear key to openssh key
55 58 chroot_exec /usr/lib/dropbear/dropbearconvert dropbear openssh /etc/dropbear-initramfs/id_rsa.dropbear /etc/dropbear-initramfs/id_rsa
56 59
57 60 # Get Public Key Part
58 61 chroot_exec /usr/bin/dropbearkey -y -f /etc/dropbear-initramfs/id_rsa.dropbear | chroot_exec tee /etc/dropbear-initramfs/id_rsa.pub
59 62
60 63 # Delete unwanted lines
61 64 sed -i '/Public/d' "${ETC_DIR}"/dropbear-initramfs/id_rsa.pub
62 65 sed -i '/Fingerprint/d' "${ETC_DIR}"/dropbear-initramfs/id_rsa.pub
63 66
64 67 # Trust the new key
65 68 cat "${ETC_DIR}"/dropbear-initramfs/id_rsa.pub > "${ETC_DIR}"/dropbear-initramfs/authorized_keys
66 69
67 70 # Save Keys - convert with putty from rsa/openssh to puttkey
68 71 cp -f "${ETC_DIR}"/dropbear-initramfs/id_rsa "${BASEDIR}"/dropbear_initramfs_key.rsa
69 72
70 73 # Get unlock script
71 74 install_exec files/initramfs/crypt_unlock.sh "${ETC_DIR}"/initramfs-tools/hooks/crypt_unlock.sh
72 75
73 76 # Enable Dropbear inside initramfs
74 77 printf "#\n# DROPBEAR: [ y | n ]\n#\n\nDROPBEAR=y\n" >> "${ETC_DIR}/initramfs-tools/initramfs.conf"
75 78
76 79 # Enable Dropbear inside initramfs
77 80 sed -i "54 i sleep 5" "${R}"/usr/share/initramfs-tools/scripts/init-premount/dropbear
78 81 fi
79 82 else
80 83 # Disable SSHD inside initramfs
81 84 printf "#\n# DROPBEAR: [ y | n ]\n#\n\nDROPBEAR=n\n" >> "${ETC_DIR}/initramfs-tools/initramfs.conf"
82 85 fi
83 86
84 87 # Add cryptsetup modules to initramfs
85 88 printf "#\n# CRYPTSETUP: [ y | n ]\n#\n\nCRYPTSETUP=y\n" >> "${ETC_DIR}/initramfs-tools/conf-hook"
86 89
87 90 # Dummy mapping required by mkinitramfs
88 91 echo "0 1 crypt $(echo "${CRYPTFS_CIPHER}" | cut -d ':' -f 1) ffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff 0 7:0 4096" | chroot_exec dmsetup create "${CRYPTFS_MAPPING}"
89 92
90 93 # Generate initramfs with encrypted root partition support
91 94 chroot_exec mkinitramfs -o "/boot/firmware/initramfs-${KERNEL_VERSION}" "${KERNEL_VERSION}"
92 95
93 96 # Remove dummy mapping
94 97 chroot_exec cryptsetup close "${CRYPTFS_MAPPING}"
95 98 else
96 99 # Generate initramfs without encrypted root partition support
97 100 chroot_exec mkinitramfs -o "/boot/firmware/initramfs-${KERNEL_VERSION}" "${KERNEL_VERSION}"
98 101 fi
99 102 fi
@@ -1,280 +1,293
1 1 #
2 2 # Setup RPi2/3 config and cmdline
3 3 #
4 4
5 5 # Load utility functions
6 6 . ./functions.sh
7 7
8 8 if [ -n "$RPI_FIRMWARE_DIR" ] && [ -d "$RPI_FIRMWARE_DIR" ] ; then
9 9 # Install boot binaries from local directory
10 10 cp "${RPI_FIRMWARE_DIR}"/boot/bootcode.bin "${BOOT_DIR}"/bootcode.bin
11 11 cp "${RPI_FIRMWARE_DIR}"/boot/fixup.dat "${BOOT_DIR}"/fixup.dat
12 12 cp "${RPI_FIRMWARE_DIR}"/boot/fixup_cd.dat "${BOOT_DIR}"/fixup_cd.dat
13 13 cp "${RPI_FIRMWARE_DIR}"/boot/fixup_x.dat "${BOOT_DIR}"/fixup_x.dat
14 14 cp "${RPI_FIRMWARE_DIR}"/boot/start.elf "${BOOT_DIR}"/start.elf
15 15 cp "${RPI_FIRMWARE_DIR}"/boot/start_cd.elf "${BOOT_DIR}"/start_cd.elf
16 16 cp "${RPI_FIRMWARE_DIR}"/boot/start_x.elf "${BOOT_DIR}"/start_x.elf
17 17 else
18 18 # Create temporary directory for boot binaries
19 19 temp_dir=$(as_nobody mktemp -d)
20 20
21 21 # Install latest boot binaries from raspberry/firmware github
22 22 as_nobody wget -q -O "${temp_dir}/bootcode.bin" "${FIRMWARE_URL}/bootcode.bin"
23 23 as_nobody wget -q -O "${temp_dir}/fixup.dat" "${FIRMWARE_URL}/fixup.dat"
24 24 as_nobody wget -q -O "${temp_dir}/fixup_cd.dat" "${FIRMWARE_URL}/fixup_cd.dat"
25 25 as_nobody wget -q -O "${temp_dir}/fixup_x.dat" "${FIRMWARE_URL}/fixup_x.dat"
26 26 as_nobody wget -q -O "${temp_dir}/start.elf" "${FIRMWARE_URL}/start.elf"
27 27 as_nobody wget -q -O "${temp_dir}/start_cd.elf" "${FIRMWARE_URL}/start_cd.elf"
28 28 as_nobody wget -q -O "${temp_dir}/start_x.elf" "${FIRMWARE_URL}/start_x.elf"
29 29
30 30 # Move downloaded boot binaries
31 31 mv "${temp_dir}/"* "${BOOT_DIR}/"
32 32
33 33 # Remove temporary directory for boot binaries
34 34 rm -fr "${temp_dir}"
35 35
36 36 # Set permissions of the boot binaries
37 37 chown -R root:root "${BOOT_DIR}"
38 38 chmod -R 600 "${BOOT_DIR}"
39 39 fi
40 40
41 41 # Setup firmware boot cmdline
42 if [ "$ENABLE_SPLITFS" = true ] ; then
43 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/sda1 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline rootwait console=tty1 init=/bin/systemd"
42 if [ "$ENABLE_USBBOOT" = true ] ; then
43 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/sda2 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline console=tty1 rootwait init=/bin/systemd"
44 44 else
45 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/mmcblk0p2 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline rootwait console=tty1 init=/bin/systemd"
45 if [ "$ENABLE_SPLITFS" = true ] ; then
46 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/sda1 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline console=tty1 rootwait init=/bin/systemd"
47 else
48 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/mmcblk0p2 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline console=tty1 rootwait init=/bin/systemd"
49 fi
46 50 fi
47 51
48 52 # Add encrypted root partition to cmdline.txt
49 53 if [ "$ENABLE_CRYPTFS" = true ] ; then
50 54 if [ "$ENABLE_SPLITFS" = true ] ; then
51 55 CMDLINE=$(echo "${CMDLINE}" | sed "s/sda1/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/sda1:${CRYPTFS_MAPPING}/")
52 56 else
53 CMDLINE=$(echo "${CMDLINE}" | sed "s/mmcblk0p2/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/mmcblk0p2:${CRYPTFS_MAPPING}/")
57 if [ "$ENABLE_USBBOOT" = true ] ; then
58 CMDLINE=$(echo "${CMDLINE}" | sed "s/sda2/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/sda2:${CRYPTFS_MAPPING}/")
59 else
60 CMDLINE=$(echo "${CMDLINE}" | sed "s/mmcblk0p2/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/mmcblk0p2:${CRYPTFS_MAPPING}/")
61 fi
54 62 fi
55 63 fi
56 64
57 65 # Enable Kernel messages on standard output
58 66 if [ "$ENABLE_PRINTK" = true ] ; then
59 67 install_readonly files/sysctl.d/83-rpi-printk.conf "${ETC_DIR}/sysctl.d/83-rpi-printk.conf"
60 68 fi
61 69
70 # Enable Kernel messages on standard output
71 if [ "$KERNEL_SECURITY" = true ] ; then
72 install_readonly files/sysctl.d/84-rpi-ASLR.conf "${ETC_DIR}/sysctl.d/84-rpi-ASLR.conf"
73 fi
74
62 75 # Install udev rule for serial alias - serial0 = console serial1=bluetooth
63 76 install_readonly files/etc/99-com.rules "${LIB_DIR}/udev/rules.d/99-com.rules"
64 77
65 78 # Remove IPv6 networking support
66 79 if [ "$ENABLE_IPV6" = false ] ; then
67 80 CMDLINE="${CMDLINE} ipv6.disable=1"
68 81 fi
69 82
70 83 # Automatically assign predictable network interface names
71 84 if [ "$ENABLE_IFNAMES" = false ] ; then
72 85 CMDLINE="${CMDLINE} net.ifnames=0"
73 86 else
74 87 CMDLINE="${CMDLINE} net.ifnames=1"
75 88 fi
76 89
77 90 # Disable Raspberry Pi console logo
78 91 if [ "$ENABLE_LOGO" = false ] ; then
79 92 CMDLINE="${CMDLINE} logo.nologo"
80 93 fi
81 94
82 95 # Strictly limit verbosity of boot up console messages
83 96 if [ "$ENABLE_SILENT_BOOT" = true ] ; then
84 97 CMDLINE="${CMDLINE} quiet loglevel=0 rd.systemd.show_status=auto rd.udev.log_priority=0"
85 98 fi
86 99
87 100 # Install firmware config
88 101 install_readonly files/boot/config.txt "${BOOT_DIR}/config.txt"
89 102
90 103 # Disable Raspberry Pi console logo
91 104 if [ "$ENABLE_SLASH" = false ] ; then
92 105 echo "disable_splash=1" >> "${BOOT_DIR}/config.txt"
93 106 fi
94 107
95 108 # Locks CPU frequency at maximum
96 109 if [ "$ENABLE_TURBO" = true ] ; then
97 110 echo "force_turbo=1" >> "${BOOT_DIR}/config.txt"
98 111 # helps to avoid sdcard corruption when force_turbo is enabled.
99 112 echo "boot_delay=1" >> "${BOOT_DIR}/config.txt"
100 113 fi
101 114
102 115 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
103 116
104 117 # Bluetooth enabled
105 118 if [ "$ENABLE_BLUETOOTH" = true ] ; then
106 119 # Create temporary directory for Bluetooth sources
107 120 temp_dir=$(as_nobody mktemp -d)
108 121
109 122 # Fetch Bluetooth sources
110 123 as_nobody git -C "${temp_dir}" clone "${BLUETOOTH_URL}"
111 124
112 125 # Copy downloaded sources
113 126 mv "${temp_dir}/pi-bluetooth" "${R}/tmp/"
114 127
115 128 # Bluetooth firmware from arch aur https://aur.archlinux.org/packages/pi-bluetooth/
116 129 as_nobody wget -q -O "${R}/tmp/pi-bluetooth/LICENCE.broadcom_bcm43xx" https://aur.archlinux.org/cgit/aur.git/plain/LICENCE.broadcom_bcm43xx?h=pi-bluetooth
117 130 as_nobody wget -q -O "${R}/tmp/pi-bluetooth/BCM43430A1.hcd" https://aur.archlinux.org/cgit/aur.git/plain/BCM43430A1.hcd?h=pi-bluetooth
118 131
119 132 # Set permissions
120 133 chown -R root:root "${R}/tmp/pi-bluetooth"
121 134
122 135 # Install tools
123 136 install_readonly "${R}/tmp/pi-bluetooth/usr/bin/btuart" "${R}/usr/bin/btuart"
124 137 install_readonly "${R}/tmp/pi-bluetooth/usr/bin/bthelper" "${R}/usr/bin/bthelper"
125 138
126 139 # make scripts executable
127 140 chmod +x "${R}/usr/bin/bthelper"
128 141 chmod +x "${R}/usr/bin/btuart"
129 142
130 143 # Install bluetooth udev rule
131 144 install_readonly "${R}/tmp/pi-bluetooth/lib/udev/rules.d/90-pi-bluetooth.rules" "${LIB_DIR}/udev/rules.d/90-pi-bluetooth.rules"
132 145
133 146 # Install Firmware Flash file and apropiate licence
134 147 mkdir -p "$BLUETOOTH_FIRMWARE_DIR"
135 148 install_readonly "${R}/tmp/pi-bluetooth/LICENCE.broadcom_bcm43xx" "${BLUETOOTH_FIRMWARE_DIR}/LICENCE.broadcom_bcm43xx"
136 149 install_readonly "${R}/tmp/pi-bluetooth/BCM43430A1.hcd" "${BLUETOOTH_FIRMWARE_DIR}/LICENCE.broadcom_bcm43xx"
137 150 install_readonly "${R}/tmp/pi-bluetooth/debian/pi-bluetooth.bthelper@.service" "${ETC_DIR}/systemd/system/pi-bluetooth.bthelper@.service"
138 151 install_readonly "${R}/tmp/pi-bluetooth/debian/pi-bluetooth.hciuart.service" "${ETC_DIR}/systemd/system/pi-bluetooth.hciuart.service"
139 152
140 153 # Remove temporary directories
141 154 rm -fr "${temp_dir}"
142 155 rm -fr "${R}"/tmp/pi-bluetooth
143 156
144 157 # Switch Pi3 Bluetooth function to use the mini-UART (ttyS0) and restore UART0/ttyAMA0 over GPIOs 14 & 15. Slow Bluetooth and slow cpu. Use /dev/ttyS0 instead of /dev/ttyAMA0
145 158 if [ "$ENABLE_MINIUART_OVERLAY" = true ] ; then
146 159
147 160 # set overlay to swap ttyAMA0 and ttyS0
148 161 echo "dtoverlay=pi3-miniuart-bt" >> "${BOOT_DIR}/config.txt"
149 162
150 163 # if force_turbo didn't lock cpu at high speed, lock it at low speed (XOR logic) or miniuart will be broken
151 164 if [ "$ENABLE_TURBO" = false ] ; then
152 165 echo "core_freq=250" >> "${BOOT_DIR}/config.txt"
153 166 fi
154 167 fi
155 168
156 169 # Activate services
157 170 chroot_exec systemctl enable pi-bluetooth.hciuart.service
158 171
159 172 else # if ENABLE_BLUETOOTH = false
160 173 # set overlay to disable bluetooth
161 174 echo "dtoverlay=pi3-disable-bt" >> "${BOOT_DIR}/config.txt"
162 175 fi # ENABLE_BLUETOOTH end
163 176 fi
164 177
165 178 # may need sudo systemctl disable hciuart
166 179 if [ "$ENABLE_CONSOLE" = true ] ; then
167 180 echo "enable_uart=1" >> "${BOOT_DIR}/config.txt"
168 181 # add string to cmdline
169 182 CMDLINE="${CMDLINE} console=serial0,115200"
170 183
171 184 # Enable serial console systemd style
172 185 chroot_exec systemctl enable serial-getty\@serial0.service
173 186 else
174 187 echo "enable_uart=0" >> "${BOOT_DIR}/config.txt"
175 188
176 189 # disable serial console systemd style
177 190 chroot_exec systemctl disable serial-getty\@"$SET_SERIAL".service
178 191 fi
179 192
180 193 if [ "$ENABLE_SYSTEMDSWAP" = true ] ; then
181 194 # Create temporary directory for systemd-swap sources
182 195 temp_dir=$(as_nobody mktemp -d)
183 196
184 197 # Fetch systemd-swap sources
185 198 as_nobody git -C "${temp_dir}" clone "${SYSTEMDSWAP_URL}"
186 199
187 200 # Copy downloaded systemd-swap sources
188 201 mv "${temp_dir}/systemd-swap" "${R}/tmp/"
189 202
190 203 # Set permissions of the systemd-swap sources
191 204 chown -R root:root "${R}/tmp/systemd-swap"
192 205
193 206 # Remove temporary directory for systemd-swap sources
194 207 rm -fr "${temp_dir}"
195 208
196 209 # Change into downloaded src dir
197 210 cd "${R}/tmp/systemd-swap" || exit
198 211
199 212 # Build package
200 213 . ./package.sh debian
201 214
202 215 # Install package
203 216 chroot_exec dpkg -i /tmp/systemd-swap/systemd-swap-*any.deb
204 217
205 218 # Enable service
206 219 chroot_exec systemctl enable systemd-swap
207 220
208 221 # Change back into script root dir
209 222 cd "${WORKDIR}" || exit
210 223 else
211 224 # Enable ZSWAP in cmdline if systemd-swap is not used
212 225 if [ "$KERNEL_ZSWAP" = true ] ; then
213 226 CMDLINE="${CMDLINE} zswap.enabled=1 zswap.max_pool_percent=25 zswap.compressor=lz4"
214 227 fi
215 228 fi
216 229
217 230 if [ "$KERNEL_SECURITY" = true ] ; then
218 231 CMDLINE="${CMDLINE} apparmor=1 security=apparmor"
219 232 fi
220 233
221 234 # Install firmware boot cmdline
222 235 echo "${CMDLINE}" > "${BOOT_DIR}/cmdline.txt"
223 236
224 237 # Setup minimal GPU memory allocation size: 16MB (no X)
225 238 if [ "$ENABLE_MINGPU" = true ] ; then
226 239 echo "gpu_mem=16" >> "${BOOT_DIR}/config.txt"
227 240 fi
228 241
229 242 # Setup boot with initramfs
230 243 if [ "$ENABLE_INITRAMFS" = true ] ; then
231 244 echo "initramfs initramfs-${KERNEL_VERSION} followkernel" >> "${BOOT_DIR}/config.txt"
232 245 fi
233 246
234 247 # Create firmware configuration and cmdline symlinks
235 248 ln -sf firmware/config.txt "${R}/boot/config.txt"
236 249 ln -sf firmware/cmdline.txt "${R}/boot/cmdline.txt"
237 250
238 251 # Install and setup kernel modules to load at boot
239 252 mkdir -p "${LIB_DIR}/modules-load.d/"
240 253 install_readonly files/modules/rpi2.conf "${LIB_DIR}/modules-load.d/rpi2.conf"
241 254
242 255 # Load hardware random module at boot
243 256 if [ "$ENABLE_HWRANDOM" = true ] && [ "$BUILD_KERNEL" = false ] ; then
244 257 sed -i "s/^# bcm2708_rng/bcm2708_rng/" "${LIB_DIR}/modules-load.d/rpi2.conf"
245 258 fi
246 259
247 260 # Load sound module at boot
248 261 if [ "$ENABLE_SOUND" = true ] ; then
249 262 sed -i "s/^# snd_bcm2835/snd_bcm2835/" "${LIB_DIR}/modules-load.d/rpi2.conf"
250 263 else
251 264 echo "dtparam=audio=off" >> "${BOOT_DIR}/config.txt"
252 265 fi
253 266
254 267 # Enable I2C interface
255 268 if [ "$ENABLE_I2C" = true ] ; then
256 269 echo "dtparam=i2c_arm=on" >> "${BOOT_DIR}/config.txt"
257 270 sed -i "s/^# i2c-bcm2708/i2c-bcm2708/" "${LIB_DIR}/modules-load.d/rpi2.conf"
258 271 sed -i "s/^# i2c-dev/i2c-dev/" "${LIB_DIR}/modules-load.d/rpi2.conf"
259 272 fi
260 273
261 274 # Enable SPI interface
262 275 if [ "$ENABLE_SPI" = true ] ; then
263 276 echo "dtparam=spi=on" >> "${BOOT_DIR}/config.txt"
264 277 echo "spi-bcm2708" >> "${LIB_DIR}/modules-load.d/rpi2.conf"
265 278 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]; then
266 279 sed -i "s/spi-bcm2708/spi-bcm2835/" "${LIB_DIR}/modules-load.d/rpi2.conf"
267 280 fi
268 281 fi
269 282
270 283 # Disable RPi2/3 under-voltage warnings
271 284 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
272 285 echo "avoid_warnings=${DISABLE_UNDERVOLT_WARNINGS}" >> "${BOOT_DIR}/config.txt"
273 286 fi
274 287
275 288 # Install kernel modules blacklist
276 289 mkdir -p "${ETC_DIR}/modprobe.d/"
277 290 install_readonly files/modules/raspi-blacklist.conf "${ETC_DIR}/modprobe.d/raspi-blacklist.conf"
278 291
279 292 # Install sysctl.d configuration files
280 293 install_readonly files/sysctl.d/81-rpi-vm.conf "${ETC_DIR}/sysctl.d/81-rpi-vm.conf"
@@ -1,105 +1,105
1 1 #
2 2 # Build and Setup U-Boot
3 3 #
4 4
5 5 # Load utility functions
6 6 . ./functions.sh
7 7
8 8 # Fetch and build U-Boot bootloader
9 9 if [ "$ENABLE_UBOOT" = true ] ; then
10 10 # Install c/c++ build environment inside the chroot
11 11 chroot_install_cc
12 12
13 13 # Copy existing U-Boot sources into chroot directory
14 14 if [ -n "$UBOOTSRC_DIR" ] && [ -d "$UBOOTSRC_DIR" ] ; then
15 15 # Copy local U-Boot sources
16 16 cp -r "${UBOOTSRC_DIR}" "${R}/tmp"
17 17 else
18 18 # Create temporary directory for U-Boot sources
19 19 temp_dir=$(as_nobody mktemp -d)
20 20
21 21 # Fetch U-Boot sources
22 22 as_nobody git -C "${temp_dir}" clone "${UBOOT_URL}"
23 23
24 24 # Copy downloaded U-Boot sources
25 25 mv "${temp_dir}/u-boot" "${R}/tmp/"
26 26
27 27 # Set permissions of the U-Boot sources
28 28 chown -R root:root "${R}/tmp/u-boot"
29 29
30 30 # Remove temporary directory for U-Boot sources
31 31 rm -fr "${temp_dir}"
32 32 fi
33 33
34 34 # Build and install U-Boot inside chroot
35 35 chroot_exec make -j"${KERNEL_THREADS}" -C /tmp/u-boot/ "${UBOOT_CONFIG}" all
36 36
37 37 # Copy compiled bootloader binary and set config.txt to load it
38 38 install_exec "${R}/tmp/u-boot/tools/mkimage" "${R}/usr/sbin/mkimage"
39 39 install_readonly "${R}/tmp/u-boot/u-boot.bin" "${BOOT_DIR}/u-boot.bin"
40 40 printf "\n# boot u-boot kernel\nkernel=u-boot.bin\n" >> "${BOOT_DIR}/config.txt"
41 41
42 42 # Install and setup U-Boot command file
43 43 install_readonly files/boot/uboot.mkimage "${BOOT_DIR}/uboot.mkimage"
44 44 printf "# Set the kernel boot command line\nsetenv bootargs \"earlyprintk ${CMDLINE}\"\n\n$(cat "${BOOT_DIR}"/uboot.mkimage)" > "${BOOT_DIR}/uboot.mkimage"
45 45
46 46 if [ "$ENABLE_INITRAMFS" = true ] ; then
47 47 # Convert generated initramfs for U-Boot using mkimage
48 48 chroot_exec /usr/sbin/mkimage -A "${KERNEL_ARCH}" -T ramdisk -C none -n "initramfs-${KERNEL_VERSION}" -d "/boot/firmware/initramfs-${KERNEL_VERSION}" "/boot/firmware/initramfs-${KERNEL_VERSION}.uboot"
49 49
50 50 # Remove original initramfs file
51 51 rm -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}"
52 52
53 53 # Configure U-Boot to load generated initramfs
54 54 printf "# Set initramfs file\nsetenv initramfs initramfs-${KERNEL_VERSION}.uboot\n\n$(cat "${BOOT_DIR}"/uboot.mkimage)" > "${BOOT_DIR}/uboot.mkimage"
55 55 printf "\nbootz \${kernel_addr_r} \${ramdisk_addr_r} \${fdt_addr_r}" >> "${BOOT_DIR}/uboot.mkimage"
56 56 else # ENABLE_INITRAMFS=false
57 57 # Remove initramfs from U-Boot mkfile
58 58 sed -i '/.*initramfs.*/d' "${BOOT_DIR}/uboot.mkimage"
59 59
60 60 if [ "$BUILD_KERNEL" = false ] ; then
61 61 # Remove dtbfile from U-Boot mkfile
62 62 sed -i '/.*dtbfile.*/d' "${BOOT_DIR}/uboot.mkimage"
63 63 printf "\nbootz \${kernel_addr_r}" >> "${BOOT_DIR}/uboot.mkimage"
64 64 else
65 65 printf "\nbootz \${kernel_addr_r} - \${fdt_addr_r}" >> "${BOOT_DIR}/uboot.mkimage"
66 66 fi
67 67 fi
68 68
69 69 if [ "$SET_ARCH" = 64 ] ; then
70 70 echo "Setting up config.txt to boot 64bit uboot"
71 71 {
72 72 printf "\n# 64bit-mode"
73 73 printf "\n# arm_control=0x200 is deprecated https://www.raspberrypi.org/documentation/configuration/config-txt/misc.md"
74 74 printf "\narm_64bit=1"
75 75 } >> "${BOOT_DIR}/config.txt"
76 76
77 77 #in 64bit uboot booti is used instead of bootz [like in KERNEL_BIN_IMAGE=zImage (armv7)|| Image(armv8)]
78 78 sed -i "s|bootz|booti|g" "${BOOT_DIR}/uboot.mkimage"
79 79 fi
80 80
81 81 # instead of sd, boot from usb device
82 if [ "$ENABLE_UBOOTUSB" = true ] ; then
82 if [ "$ENABLE_USBBOOT" = true ] ; then
83 83 sed -i "s|mmc|usb|g" "${BOOT_DIR}/uboot.mkimage"
84 84 fi
85 85
86 86 # Set mkfile to use the correct dtb file
87 87 sed -i "s|bcm2709-rpi-2-b.dtb|${DTB_FILE}|" "${BOOT_DIR}/uboot.mkimage"
88 88
89 89 # Set mkfile to use the correct mach id
90 90 if [ "$ENABLE_QEMU" = true ] ; then
91 91 sed -i "s/^\(setenv machid \).*/\10x000008e0/" "${BOOT_DIR}/uboot.mkimage"
92 92 fi
93 93
94 94 # Set mkfile to use kernel image
95 95 sed -i "s|kernel7.img|${KERNEL_IMAGE}|" "${BOOT_DIR}/uboot.mkimage"
96 96
97 97 # Remove all leading blank lines
98 98 sed -i "/./,\$!d" "${BOOT_DIR}/uboot.mkimage"
99 99
100 100 # Generate U-Boot bootloader image
101 101 chroot_exec /usr/sbin/mkimage -A "${KERNEL_ARCH}" -O linux -T script -C none -a 0x00000000 -e 0x00000000 -n "RPi${RPI_MODEL}" -d /boot/firmware/uboot.mkimage /boot/firmware/boot.scr
102 102
103 103 # Remove U-Boot sources
104 104 rm -fr "${R}/tmp/u-boot"
105 105 fi
@@ -1,867 +1,863
1 1 #!/bin/sh
2 2 ########################################################################
3 3 # rpi23-gen-image.sh 2015-2017
4 4 #
5 5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 6 #
7 7 # This program is free software; you can redistribute it and/or
8 8 # modify it under the terms of the GNU General Public License
9 9 # as published by the Free Software Foundation; either version 2
10 10 # of the License, or (at your option) any later version.
11 11 #
12 12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 13 #
14 14 # Big thanks for patches and enhancements by 20+ github contributors!
15 15 ########################################################################
16 16
17 17 # Are we running as root?
18 18 if [ "$(id -u)" -ne "0" ] ; then
19 19 echo "error: this script must be executed with root privileges!"
20 20 exit 1
21 21 fi
22 22
23 23 # Check if ./functions.sh script exists
24 24 if [ ! -r "./functions.sh" ] ; then
25 25 echo "error: './functions.sh' required script not found!"
26 26 exit 1
27 27 fi
28 28
29 29 # Load utility functions
30 30 . ./functions.sh
31 31
32 32 # Load parameters from configuration template file
33 33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 34 use_template
35 35 fi
36 36
37 37 # Introduce settings
38 38 set -e
39 39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
40 40 set -x
41 41
42 42 # Raspberry Pi model configuration
43 43 RPI_MODEL=${RPI_MODEL:=2}
44 44
45 45 # Debian release
46 46 RELEASE=${RELEASE:=buster}
47 47
48 48 # Kernel Branch
49 49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50 50
51 51 # URLs
52 52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
59 59 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
60 60 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
61 61 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
62 62
63 63 # Kernel deb packages for 32bit kernel
64 64 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
65 65 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
66 66 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
67 67 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
68 68 # Default precompiled 64bit kernel
69 69 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
70 70 # Generic
71 71 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
72 72 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
73 73 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
74 74
75 75 # Build directories
76 76 WORKDIR=$(pwd)
77 77 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
78 78 BUILDDIR="${BASEDIR}/build"
79 79
80 80 # Chroot directories
81 81 R="${BUILDDIR}/chroot"
82 82 ETC_DIR="${R}/etc"
83 83 LIB_DIR="${R}/lib"
84 84 BOOT_DIR="${R}/boot/firmware"
85 85 KERNEL_DIR="${R}/usr/src/linux"
86 86 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
87 87 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
88 88
89 89 # Firmware directory: Blank if download from github
90 90 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
91 91
92 92 # General settings
93 93 SET_ARCH=${SET_ARCH:=32}
94 94 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
95 95 PASSWORD=${PASSWORD:=raspberry}
96 96 USER_PASSWORD=${USER_PASSWORD:=raspberry}
97 97 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
98 98 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
99 99 EXPANDROOT=${EXPANDROOT:=true}
100 100
101 101 # Keyboard settings
102 102 XKB_MODEL=${XKB_MODEL:=""}
103 103 XKB_LAYOUT=${XKB_LAYOUT:=""}
104 104 XKB_VARIANT=${XKB_VARIANT:=""}
105 105 XKB_OPTIONS=${XKB_OPTIONS:=""}
106 106
107 107 # Network settings (DHCP)
108 108 ENABLE_DHCP=${ENABLE_DHCP:=true}
109 109
110 110 # Network settings (static)
111 111 NET_ADDRESS=${NET_ADDRESS:=""}
112 112 NET_GATEWAY=${NET_GATEWAY:=""}
113 113 NET_DNS_1=${NET_DNS_1:=""}
114 114 NET_DNS_2=${NET_DNS_2:=""}
115 115 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
116 116 NET_NTP_1=${NET_NTP_1:=""}
117 117 NET_NTP_2=${NET_NTP_2:=""}
118 118
119 119 # APT settings
120 120 APT_PROXY=${APT_PROXY:=""}
121 121 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
122 122 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
123 123
124 124 # Feature settings
125 125 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
126 126 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
127 127 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
128 128 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
129 129 ENABLE_I2C=${ENABLE_I2C:=false}
130 130 ENABLE_SPI=${ENABLE_SPI:=false}
131 131 ENABLE_IPV6=${ENABLE_IPV6:=true}
132 132 ENABLE_SSHD=${ENABLE_SSHD:=true}
133 133 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
134 134 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
135 135 ENABLE_SOUND=${ENABLE_SOUND:=true}
136 136 ENABLE_DBUS=${ENABLE_DBUS:=true}
137 137 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
138 138 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
139 139 ENABLE_XORG=${ENABLE_XORG:=false}
140 140 ENABLE_WM=${ENABLE_WM:=""}
141 141 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
142 142 ENABLE_USER=${ENABLE_USER:=true}
143 143 USER_NAME=${USER_NAME:="pi"}
144 144 ENABLE_ROOT=${ENABLE_ROOT:=false}
145 145 ENABLE_QEMU=${ENABLE_QEMU:=false}
146 146 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
147 147
148 148 # SSH settings
149 149 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
150 150 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
151 151 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
152 152 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
153 153 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
154 154
155 155 # Advanced settings
156 156 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
157 157 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
158 158 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
159 159 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
160 160 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
161 ENABLE_UBOOTUSB=${ENABLE_UBOOTUSB=false}
161 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
162 162 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
163 163 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
164 164 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
165 165 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
166 166 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
167 167 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
168 168 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
169 169 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
170 170 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
171 171 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
172 172 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
173 173 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
174 174 ENABLE_LOGO=${ENABLE_LOGO:=true}
175 175 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
176 176 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
177 177
178 178 # Kernel compilation settings
179 179 BUILD_KERNEL=${BUILD_KERNEL:=true}
180 180 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
181 181 KERNEL_THREADS=${KERNEL_THREADS:=1}
182 182 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
183 183 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
184 184 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
185 185 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
186 186 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
187 187 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
188 188 KERNEL_VIRT=${KERNEL_VIRT:=false}
189 189 KERNEL_BPF=${KERNEL_BPF:=false}
190 190 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=powersave}
191 191 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
192 192 KERNEL_NF=${KERNEL_NF:=false}
193 193
194 194 # Kernel compilation from source directory settings
195 195 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
196 196 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
197 197 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
198 198 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
199 199
200 200 # Reduce disk usage settings
201 201 REDUCE_APT=${REDUCE_APT:=true}
202 202 REDUCE_DOC=${REDUCE_DOC:=true}
203 203 REDUCE_MAN=${REDUCE_MAN:=true}
204 204 REDUCE_VIM=${REDUCE_VIM:=false}
205 205 REDUCE_BASH=${REDUCE_BASH:=false}
206 206 REDUCE_HWDB=${REDUCE_HWDB:=true}
207 207 REDUCE_SSHD=${REDUCE_SSHD:=true}
208 208 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
209 209
210 210 # Encrypted filesystem settings
211 211 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
212 212 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
213 213 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
214 214 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
215 215 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
216 216 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
217 217 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
218 218 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
219 219 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
220 220
221 221 # Chroot scripts directory
222 222 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
223 223
224 224 # Packages required in the chroot build environment
225 225 APT_INCLUDES=${APT_INCLUDES:=""}
226 226 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
227 227
228 228 # Packages to exclude from chroot build environment
229 229 APT_EXCLUDES=${APT_EXCLUDES:=""}
230 230
231 231 # Packages required for bootstrapping
232 232 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
233 233 MISSING_PACKAGES=""
234 234
235 235 # Packages installed for c/c++ build environment in chroot (keep empty)
236 236 COMPILER_PACKAGES=""
237 237
238 238 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
239 239 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
240 240 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
241 241 APT_PROXY=http://127.0.0.1:3142/
242 242 fi
243 243
244 244 # Setup architecture specific settings
245 245 if [ -n "$SET_ARCH" ] ; then
246 246 # 64-bit configuration
247 247 if [ "$SET_ARCH" = 64 ] ; then
248 248 # General 64-bit depended settings
249 249 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
250 250 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
251 251 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
252 252
253 253 # Raspberry Pi model specific settings
254 254 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
255 255 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
256 256 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
257 257 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
258 258 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
259 259 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
260 260 else
261 261 echo "error: Only Raspberry PI 3 and 3B+ support 64-bit"
262 262 exit 1
263 263 fi
264 264 fi
265 265
266 266 # 32-bit configuration
267 267 if [ "$SET_ARCH" = 32 ] ; then
268 268 # General 32-bit dependend settings
269 269 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
270 270 KERNEL_ARCH=${KERNEL_ARCH:=arm}
271 271 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
272 272
273 273 # Raspberry Pi model specific settings
274 274 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
275 275 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
276 276 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
277 277 RELEASE_ARCH=${RELEASE_ARCH:=armel}
278 278 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
279 279 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
280 280 fi
281 281
282 282 # Raspberry Pi model specific settings
283 283 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
284 284 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
285 285 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
286 286 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
287 287 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
288 288 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
289 289 fi
290 290 fi
291 291 # SET_ARCH not set
292 292 else
293 293 echo "error: Please set '32' or '64' as value for SET_ARCH"
294 294 exit 1
295 295 fi
296 296 # Device specific configuration and U-Boot configuration
297 297 case "$RPI_MODEL" in
298 298 0)
299 299 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
300 300 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
301 301 ;;
302 302 1)
303 303 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
304 304 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
305 305 ;;
306 306 1P)
307 307 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
308 308 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
309 309 ;;
310 310 2)
311 311 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
312 312 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
313 313 ;;
314 314 3)
315 315 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
316 316 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
317 317 ;;
318 318 3P)
319 319 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
320 320 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
321 321 ;;
322 322 *)
323 323 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
324 324 exit 1
325 325 ;;
326 326 esac
327 327
328 if [ "$ENABLE_UBOOTUSB" = true ] ; then
329 if [ "$ENABLE_UBOOT" = false ] ; then
330 echo "error: Enabling UBOOTUSB requires u-boot to be enabled"
331 exit 1
332 fi
333 if [ "$RPI_MODEL" != 3 ] || [ "$RPI_MODEL" != 3P ] ; then
334 echo "error: Enabling UBOOTUSB requires Raspberry 3"
335 exit 1
336 fi
337 fi
338
339 328 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
340 329 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
341 330 # Include bluetooth packages on supported boards
342 331 if [ "$ENABLE_BLUETOOTH" = true ] ; then
343 332 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
344 333 fi
345 334 if [ "$ENABLE_WIRELESS" = true ] ; then
346 335 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb"
347 336 fi
348 337 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
349 338 # Check if the internal wireless interface is not supported by the RPi model
350 339 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
351 340 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
352 341 exit 1
353 342 fi
354 343 fi
355 344
356 345 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
357 346 echo "error: You have to compile kernel sources, if you want to enable nexmon"
358 347 exit 1
359 348 fi
360 349
361 350 # Prepare date string for default image file name
362 351 DATE="$(date +%Y-%m-%d)"
363 352 if [ -z "$KERNEL_BRANCH" ] ; then
364 353 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
365 354 else
366 355 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
367 356 fi
368 357
369 358 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
370 359 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
371 360 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
372 361 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
373 362 exit 1
374 363 fi
375 364 fi
376 365
377 366 # Add cmake to compile videocore sources
378 367 if [ "$ENABLE_VIDEOCORE" = true ] ; then
379 368 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
380 369 fi
381 370
382 371 # Add deps for nexmon
383 372 if [ "$ENABLE_NEXMON" = true ] ; then
384 373 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
385 374 fi
386 375
387 376 # Add libncurses5 to enable kernel menuconfig
388 377 if [ "$KERNEL_MENUCONFIG" = true ] ; then
389 378 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
390 379 fi
391 380
392 381 # Add ccache compiler cache for (faster) kernel cross (re)compilation
393 382 if [ "$KERNEL_CCACHE" = true ] ; then
394 383 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
395 384 fi
396 385
397 386 # Add cryptsetup package to enable filesystem encryption
398 387 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
399 388 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
400 389 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
401 390
402 391 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
403 392 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
404 393 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
405 394 fi
406 395
407 396 if [ -z "$CRYPTFS_PASSWORD" ] ; then
408 397 echo "error: no password defined (CRYPTFS_PASSWORD)!"
409 398 exit 1
410 399 fi
411 400 ENABLE_INITRAMFS=true
412 401 fi
413 402
414 403 # Add initramfs generation tools
415 404 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
416 405 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
417 406 fi
418 407
419 408 # Add device-tree-compiler required for building the U-Boot bootloader
420 409 if [ "$ENABLE_UBOOT" = true ] ; then
421 410 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
422 411 fi
423 412
413 if [ "$ENABLE_USBBOOT" = true ] ; then
414 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
415 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
416 exit 1
417 fi
418 fi
419
424 420 # Check if root SSH (v2) public key file exists
425 421 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
426 422 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
427 423 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
428 424 exit 1
429 425 fi
430 426 fi
431 427
432 428 # Check if $USER_NAME SSH (v2) public key file exists
433 429 if [ -n "$SSH_USER_PUB_KEY" ] ; then
434 430 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
435 431 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
436 432 exit 1
437 433 fi
438 434 fi
439 435
440 436 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
441 437 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
442 438 exit 1
443 439 fi
444 440
445 441 # Check if all required packages are installed on the build system
446 442 for package in $REQUIRED_PACKAGES ; do
447 443 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
448 444 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
449 445 fi
450 446 done
451 447
452 448 # If there are missing packages ask confirmation for install, or exit
453 449 if [ -n "$MISSING_PACKAGES" ] ; then
454 450 echo "the following packages needed by this script are not installed:"
455 451 echo "$MISSING_PACKAGES"
456 452
457 453 printf "\ndo you want to install the missing packages right now? [y/n] "
458 454 read -r confirm
459 455 [ "$confirm" != "y" ] && exit 1
460 456
461 457 # Make sure all missing required packages are installed
462 458 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
463 459 fi
464 460
465 461 # Check if ./bootstrap.d directory exists
466 462 if [ ! -d "./bootstrap.d/" ] ; then
467 463 echo "error: './bootstrap.d' required directory not found!"
468 464 exit 1
469 465 fi
470 466
471 467 # Check if ./files directory exists
472 468 if [ ! -d "./files/" ] ; then
473 469 echo "error: './files' required directory not found!"
474 470 exit 1
475 471 fi
476 472
477 473 # Check if specified KERNELSRC_DIR directory exists
478 474 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
479 475 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
480 476 exit 1
481 477 fi
482 478
483 479 # Check if specified UBOOTSRC_DIR directory exists
484 480 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
485 481 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
486 482 exit 1
487 483 fi
488 484
489 485 # Check if specified VIDEOCORESRC_DIR directory exists
490 486 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
491 487 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
492 488 exit 1
493 489 fi
494 490
495 491 # Check if specified FBTURBOSRC_DIR directory exists
496 492 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
497 493 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
498 494 exit 1
499 495 fi
500 496
501 497 # Check if specified NEXMONSRC_DIR directory exists
502 498 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
503 499 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
504 500 exit 1
505 501 fi
506 502
507 503 # Check if specified CHROOT_SCRIPTS directory exists
508 504 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
509 505 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
510 506 exit 1
511 507 fi
512 508
513 509 # Check if specified device mapping already exists (will be used by cryptsetup)
514 510 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
515 511 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
516 512 exit 1
517 513 fi
518 514
519 515 # Don't clobber an old build
520 516 if [ -e "$BUILDDIR" ] ; then
521 517 echo "error: directory ${BUILDDIR} already exists, not proceeding"
522 518 exit 1
523 519 fi
524 520
525 521 # Setup chroot directory
526 522 mkdir -p "${R}"
527 523
528 524 # Check if build directory has enough of free disk space >512MB
529 525 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
530 526 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
531 527 exit 1
532 528 fi
533 529
534 530 set -x
535 531
536 532 # Call "cleanup" function on various signals and errors
537 533 trap cleanup 0 1 2 3 6
538 534
539 535 # Add required packages for the minbase installation
540 536 if [ "$ENABLE_MINBASE" = true ] ; then
541 537 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
542 538 fi
543 539
544 540 # Add parted package, required to get partprobe utility
545 541 if [ "$EXPANDROOT" = true ] ; then
546 542 APT_INCLUDES="${APT_INCLUDES},parted"
547 543 fi
548 544
549 545 # Add dbus package, recommended if using systemd
550 546 if [ "$ENABLE_DBUS" = true ] ; then
551 547 APT_INCLUDES="${APT_INCLUDES},dbus"
552 548 fi
553 549
554 550 # Add iptables IPv4/IPv6 package
555 551 if [ "$ENABLE_IPTABLES" = true ] ; then
556 552 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
557 553 fi
558 554 # Add apparmor for KERNEL_SECURITY
559 555 if [ "$KERNEL_SECURITY" = true ] ; then
560 556 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
561 557 fi
562 558
563 559 # Add openssh server package
564 560 if [ "$ENABLE_SSHD" = true ] ; then
565 561 APT_INCLUDES="${APT_INCLUDES},openssh-server"
566 562 fi
567 563
568 564 # Add alsa-utils package
569 565 if [ "$ENABLE_SOUND" = true ] ; then
570 566 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
571 567 fi
572 568
573 569 # Add rng-tools package
574 570 if [ "$ENABLE_HWRANDOM" = true ] ; then
575 571 APT_INCLUDES="${APT_INCLUDES},rng-tools"
576 572 fi
577 573
578 574 # Add fbturbo video driver
579 575 if [ "$ENABLE_FBTURBO" = true ] ; then
580 576 # Enable xorg package dependencies
581 577 ENABLE_XORG=true
582 578 fi
583 579
584 580 # Add user defined window manager package
585 581 if [ -n "$ENABLE_WM" ] ; then
586 582 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
587 583
588 584 # Enable xorg package dependencies
589 585 ENABLE_XORG=true
590 586 fi
591 587
592 588 # Add xorg package
593 589 if [ "$ENABLE_XORG" = true ] ; then
594 590 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
595 591 fi
596 592
597 593 # Replace selected packages with smaller clones
598 594 if [ "$ENABLE_REDUCE" = true ] ; then
599 595 # Add levee package instead of vim-tiny
600 596 if [ "$REDUCE_VIM" = true ] ; then
601 597 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
602 598 fi
603 599
604 600 # Add dropbear package instead of openssh-server
605 601 if [ "$REDUCE_SSHD" = true ] ; then
606 602 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
607 603 fi
608 604 fi
609 605
610 606 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
611 607 if [ "$ENABLE_SYSVINIT" = false ] ; then
612 608 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
613 609 fi
614 610
615 611 # Configure kernel sources if no KERNELSRC_DIR
616 612 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
617 613 KERNELSRC_CONFIG=true
618 614 fi
619 615
620 616 # Configure reduced kernel
621 617 if [ "$KERNEL_REDUCE" = true ] ; then
622 618 KERNELSRC_CONFIG=false
623 619 fi
624 620
625 621 # Configure qemu compatible kernel
626 622 if [ "$ENABLE_QEMU" = true ] ; then
627 623 DTB_FILE=vexpress-v2p-ca15_a7.dtb
628 624 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
629 625 KERNEL_DEFCONFIG="vexpress_defconfig"
630 626 if [ "$KERNEL_MENUCONFIG" = false ] ; then
631 627 KERNEL_OLDDEFCONFIG=true
632 628 fi
633 629 fi
634 630
635 631 # Execute bootstrap scripts
636 632 for SCRIPT in bootstrap.d/*.sh; do
637 633 head -n 3 "$SCRIPT"
638 634 . "$SCRIPT"
639 635 done
640 636
641 637 ## Execute custom bootstrap scripts
642 638 if [ -d "custom.d" ] ; then
643 639 for SCRIPT in custom.d/*.sh; do
644 640 . "$SCRIPT"
645 641 done
646 642 fi
647 643
648 644 # Execute custom scripts inside the chroot
649 645 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
650 646 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
651 647 chroot_exec /bin/bash -x <<'EOF'
652 648 for SCRIPT in /chroot_scripts/* ; do
653 649 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
654 650 $SCRIPT
655 651 fi
656 652 done
657 653 EOF
658 654 rm -rf "${R}/chroot_scripts"
659 655 fi
660 656
661 657 # Remove c/c++ build environment from the chroot
662 658 chroot_remove_cc
663 659
664 660 # Generate required machine-id
665 661 MACHINE_ID=$(dbus-uuidgen)
666 662 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
667 663 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
668 664
669 665 # APT Cleanup
670 666 chroot_exec apt-get -y clean
671 667 chroot_exec apt-get -y autoclean
672 668 chroot_exec apt-get -y autoremove
673 669
674 670 # Unmount mounted filesystems
675 671 umount -l "${R}/proc"
676 672 umount -l "${R}/sys"
677 673
678 674 # Clean up directories
679 675 rm -rf "${R}/run/*"
680 676 rm -rf "${R}/tmp/*"
681 677
682 678 # Clean up APT proxy settings
683 679 if [ "$KEEP_APT_PROXY" = false ] ; then
684 680 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
685 681 fi
686 682
687 683 # Clean up files
688 684 rm -f "${ETC_DIR}/ssh/ssh_host_*"
689 685 rm -f "${ETC_DIR}/dropbear/dropbear_*"
690 686 rm -f "${ETC_DIR}/apt/sources.list.save"
691 687 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
692 688 rm -f "${ETC_DIR}/*-"
693 689 rm -f "${ETC_DIR}/resolv.conf"
694 690 rm -f "${R}/root/.bash_history"
695 691 rm -f "${R}/var/lib/urandom/random-seed"
696 692 rm -f "${R}/initrd.img"
697 693 rm -f "${R}/vmlinuz"
698 694 rm -f "${R}${QEMU_BINARY}"
699 695
700 696 if [ "$ENABLE_QEMU" = true ] ; then
701 697 # Setup QEMU directory
702 698 mkdir "${BASEDIR}/qemu"
703 699
704 700 # Copy kernel image to QEMU directory
705 701 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
706 702
707 703 # Copy kernel config to QEMU directory
708 704 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
709 705
710 706 # Copy kernel dtbs to QEMU directory
711 707 for dtb in "${BOOT_DIR}/"*.dtb ; do
712 708 if [ -f "${dtb}" ] ; then
713 709 install_readonly "${dtb}" "${BASEDIR}/qemu/"
714 710 fi
715 711 done
716 712
717 713 # Copy kernel overlays to QEMU directory
718 714 if [ -d "${BOOT_DIR}/overlays" ] ; then
719 715 # Setup overlays dtbs directory
720 716 mkdir "${BASEDIR}/qemu/overlays"
721 717
722 718 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
723 719 if [ -f "${dtb}" ] ; then
724 720 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
725 721 fi
726 722 done
727 723 fi
728 724
729 725 # Copy u-boot files to QEMU directory
730 726 if [ "$ENABLE_UBOOT" = true ] ; then
731 727 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
732 728 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
733 729 fi
734 730 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
735 731 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
736 732 fi
737 733 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
738 734 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
739 735 fi
740 736 fi
741 737
742 738 # Copy initramfs to QEMU directory
743 739 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
744 740 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
745 741 fi
746 742 fi
747 743
748 744 # Calculate size of the chroot directory in KB
749 745 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
750 746
751 747 # Calculate the amount of needed 512 Byte sectors
752 748 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
753 749 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
754 750 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
755 751
756 752 # The root partition is EXT4
757 753 # This means more space than the actual used space of the chroot is used.
758 754 # As overhead for journaling and reserved blocks 35% are added.
759 755 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
760 756
761 757 # Calculate required image size in 512 Byte sectors
762 758 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
763 759
764 760 # Prepare image file
765 761 if [ "$ENABLE_SPLITFS" = true ] ; then
766 762 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
767 763 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
768 764 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
769 765 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
770 766
771 767 # Write firmware/boot partition tables
772 768 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
773 769 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
774 770 EOM
775 771
776 772 # Write root partition table
777 773 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
778 774 ${TABLE_SECTORS},${ROOT_SECTORS},83
779 775 EOM
780 776
781 777 # Setup temporary loop devices
782 778 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
783 779 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
784 780 else # ENABLE_SPLITFS=false
785 781 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
786 782 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
787 783
788 784 # Write partition table
789 785 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
790 786 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
791 787 ${ROOT_OFFSET},${ROOT_SECTORS},83
792 788 EOM
793 789
794 790 # Setup temporary loop devices
795 791 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
796 792 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
797 793 fi
798 794
799 795 if [ "$ENABLE_CRYPTFS" = true ] ; then
800 796 # Create dummy ext4 fs
801 797 mkfs.ext4 "$ROOT_LOOP"
802 798
803 799 # Setup password keyfile
804 800 touch .password
805 801 chmod 600 .password
806 802 echo -n ${CRYPTFS_PASSWORD} > .password
807 803
808 804 # Initialize encrypted partition
809 805 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
810 806
811 807 # Open encrypted partition and setup mapping
812 808 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
813 809
814 810 # Secure delete password keyfile
815 811 shred -zu .password
816 812
817 813 # Update temporary loop device
818 814 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
819 815
820 816 # Wipe encrypted partition (encryption cipher is used for randomness)
821 817 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
822 818 fi
823 819
824 820 # Build filesystems
825 821 mkfs.vfat "$FRMW_LOOP"
826 822 mkfs.ext4 "$ROOT_LOOP"
827 823
828 824 # Mount the temporary loop devices
829 825 mkdir -p "$BUILDDIR/mount"
830 826 mount "$ROOT_LOOP" "$BUILDDIR/mount"
831 827
832 828 mkdir -p "$BUILDDIR/mount/boot/firmware"
833 829 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
834 830
835 831 # Copy all files from the chroot to the loop device mount point directory
836 832 rsync -a "${R}/" "$BUILDDIR/mount/"
837 833
838 834 # Unmount all temporary loop devices and mount points
839 835 cleanup
840 836
841 837 # Create block map file(s) of image(s)
842 838 if [ "$ENABLE_SPLITFS" = true ] ; then
843 839 # Create block map files for "bmaptool"
844 840 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
845 841 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
846 842
847 843 # Image was successfully created
848 844 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
849 845 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
850 846 else
851 847 # Create block map file for "bmaptool"
852 848 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
853 849
854 850 # Image was successfully created
855 851 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
856 852
857 853 # Create qemu qcow2 image
858 854 if [ "$ENABLE_QEMU" = true ] ; then
859 855 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
860 856 QEMU_SIZE=16G
861 857
862 858 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
863 859 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
864 860
865 861 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
866 862 fi
867 863 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant